/**
 * Orbipay-Checkout APIs
 * API specification to use the Orbipay-Checkout APIs. This documentation covers the Merchant Account Management and PaymentVO Management related APIs. 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: checkout.orbipay@alacriti.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CustomerAccount', 'model/Payer', 'model/FundingAccount', 'model/Fee', 'model/Customer'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CustomerAccount'), require('./Payer'), require('./FundingAccount'), require('./Fee'), require('./Customer'));
  } else {
    // Browser globals (root is window)
    if (!root.OrbipayCheckoutApIs) {
      root.OrbipayCheckoutApIs = {};
    }
    root.OrbipayCheckoutApIs.PaymentVO = factory(root.OrbipayCheckoutApIs.ApiClient, root.OrbipayCheckoutApIs.CustomerAccount, root.OrbipayCheckoutApIs.Payer, root.OrbipayCheckoutApIs.FundingAccount, root.OrbipayCheckoutApIs.Fee, root.OrbipayCheckoutApIs.Customer);
  }
}(this, function(ApiClient, CustomerAccount, Payer, FundingAccount, Fee, Customer) {
  'use strict';




  /**
   * The PaymentVO model module.
   * @module model/PaymentVO
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>PaymentVO</code>.
   * @alias module:model/PaymentVO
   * @class
   */
  var exports = function() {
    var _this = this;










  };

  /**
   * Constructs a <code>PaymentVO</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PaymentVO} obj Optional instance to populate.
   * @return {module:model/PaymentVO} The populated <code>PaymentVO</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('fee')) {
        obj['fee'] = Fee.constructFromObject(data['fee']);
      }
      if (data.hasOwnProperty('payment_status')) {
        obj['payment_status'] = ApiClient.convertToType(data['payment_status'], 'String');
      }
      if (data.hasOwnProperty('payment_method')) {
        obj['payment_method'] = ApiClient.convertToType(data['payment_method'], 'String');
      }
      if (data.hasOwnProperty('confirmation_number')) {
        obj['confirmation_number'] = ApiClient.convertToType(data['confirmation_number'], 'String');
      }
      if (data.hasOwnProperty('custom_fields')) {
        obj['custom_fields'] = ApiClient.convertToType(data['custom_fields'], 'Object');
      }
      if (data.hasOwnProperty('currency_code3d')) {
        obj['currency_code3d'] = ApiClient.convertToType(data['currency_code3d'], 'String');
      }
      if (data.hasOwnProperty('amount')) {
        obj['amount'] = ApiClient.convertToType(data['amount'], 'String');
      }
      
      if (data.hasOwnProperty('payment_date')) {
        obj['payment_date'] = ApiClient.convertToType(data['payment_date'], 'String');
      }
      if (data.hasOwnProperty('payment_request_date')) {
        obj['payment_request_date'] = ApiClient.convertToType(data['payment_request_date'], 'String');
      }
      if (data.hasOwnProperty('payment_amount_type')) {
        obj['payment_amount_type'] = ApiClient.convertToType(data['payment_amount_type'], 'String');
      }
      if (data.hasOwnProperty('payment_reference')) {
        obj['payment_reference'] = ApiClient.convertToType(data['payment_reference'], 'String');
      }
      if (data.hasOwnProperty('expected_payment_settlement_date')) {
        obj['expected_payment_settlement_date'] = ApiClient.convertToType(data['expected_payment_settlement_date'], 'String');
      }
      if (data.hasOwnProperty('payment_schedule_type')) {
        obj['payment_schedule_type'] = ApiClient.convertToType(data['payment_schedule_type'], 'String');
      }
      if (data.hasOwnProperty('payment_entry_date')) {
        obj['payment_entry_date'] = ApiClient.convertToType(data['payment_entry_date'], 'String');
      }
      if (data.hasOwnProperty('payment_return_date')) {
        obj['payment_return_date'] = ApiClient.convertToType(data['payment_return_date'], 'String');
      }
      if (data.hasOwnProperty('return_code')) {
        obj['return_code'] = ApiClient.convertToType(data['return_code'], 'String');
      }
      if (data.hasOwnProperty('payer')) {
        obj['payer'] = Payer.constructFromObject(data['payer']);
      }
      if (data.hasOwnProperty('funding_account')) {
        obj['funding_account'] = FundingAccount.constructFromObject(data['funding_account']);
      }
      if (data.hasOwnProperty('customer_account')) {
        obj['customer_account'] = CustomerAccount.constructFromObject(data['customer_account']);
      }
      if (data.hasOwnProperty('customer')) {
        obj['customer'] = CustomerAccount.constructFromObject(data['customer']);
      }
     
    }
    return obj;
  }

/**
   * Id is a unique identifier assigned to a payment in OrbiPay-Checkout system.
   * @member {String} url
   */
  exports.prototype['url'] = undefined;
  /**
   * Id is a unique identifier assigned to a payment in OrbiPay-Checkout system.
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * @member {module:model/Fee} fee
   */
  exports.prototype['fee'] = undefined;  
  /**
   * Status of the charge
   * @member {String} payment_status
   */
  exports.prototype['payment_status'] = undefined;
  /**
   * A unique reference assigned to the charge by Orbipay-Checkout system for any future communications
   * @member {String} payment_method
   */
  exports.prototype['payment_method'] = undefined;
  /**
   * A unique reference assigned to the charge by Orbipay-Checkout system for any future communications
   * @member {String} confirmation_number
   */
  exports.prototype['confirmation_number'] = undefined;
  /**
   * @member {Object} custom_fields
   */
  exports.prototype['custom_fields'] = undefined;
  /**
   * 3 character ISO currency code should be provided in currencyCode3d field defaulted to USD if its not populated.
   * @member {String} currency_code3d
   */
  exports.prototype['currency_code3d'] = undefined;
  /**
   * Amount fields are of format N [9, 2] with . as decimal separator         (for e.g. 100.20).
   * @member {String} amount
   */
  exports.prototype['amount'] = undefined;
  /**
   * payment date should be in mm/dd/yyyy.
   * @member {String} payment_date
   */
  exports.prototype['payment_date'] = undefined;
  /**
   * @member {String} payment_request_date
   */
  exports.prototype['payment_request_date'] = undefined;
  /**
   * @member {String} payment_amount_type
   */
  exports.prototype['payment_amount_type'] = undefined;
  /**
   * @member {String} payment_reference
   */
  exports.prototype['payment_reference'] = undefined;
  /**
   * @member {String} expected_payment_settlement_date
   */
  exports.prototype['expected_payment_settlement_date'] = undefined;
  /**
   * @member {String} payment_schedule_type
   */
  exports.prototype['payment_schedule_type'] = undefined;
  /**
   * @member {String} payment_entry_date
   */
  exports.prototype['payment_entry_date'] = undefined;
  /**
   * @member {String} payment_return_date
   */
  exports.prototype['payment_return_date'] = undefined;
  /**
   * @member {String} return_code
   */
  exports.prototype['return_code'] = undefined;
  /**
   * @member {module:model/Payer} payer
   */
  exports.prototype['payer'] = undefined;
  /**
   * @member {module:model/FundingAccount} funding_account
   */
  exports.prototype['funding_account'] = undefined;
  /**
   * @member {module:model/CustomerAccount} customer_account
   */
  exports.prototype['customer_account'] = undefined;
  /**
   * @member {module:model/Customer} customer
   */
  exports.prototype['customer'] = undefined;
  /**
   * Allowed values for the <code>status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.ChargeStatusEnum = {
    /**
     * value: "scheduled"
     * @const
     */
    "scheduled": "scheduled",
    /**
     * value: "cancelled"
     * @const
     */
    "cancelled": "cancelled",
    /**
     * value: "processing"
     * @const
     */
    "processing": "processing",
    /**
     * value: "processed"
     * @const
     */
    "processed": "processed",
    /**
     * value: "returned"
     * @const
     */
    "returned": "returned",
    /**
     * value: "declined"
     * @const
     */
    "declined": "declined",
    /**
     * value: "disputed"
     * @const
     */
    "disputed": "disputed",
    /**
     * value: "refunded"
     * @const
     */
    "refunded": "refunded",
    /**
     * value: "failed"
     * @const
     */
    "failed": "failed",
    /**
     * value: "submitted"
     * @const
     */
    "submitted": "submitted"  };


  return exports;
}));


